searchNodes=[{"doc":"A collection of functions useful for programming challenges and beyond","ref":"Multitool.html","title":"Multitool","type":"module"},{"doc":"Useful operations when dealing with Lists","ref":"Multitool.Collections.ListOperations.html","title":"Multitool.Collections.ListOperations","type":"module"},{"doc":"Returns a List containing all permutations of the given List Parameters list : The list to generate permutations of Examples iex&gt; permutations ( [ &quot;a&quot; , &quot;b&quot; ] ) [ [ &quot;a&quot; , &quot;b&quot; ] , [ &quot;b&quot; , &quot;a&quot; ] ] iex&gt; permutations ( [ ] ) [ [ ] ]","ref":"Multitool.Collections.ListOperations.html#permutations/1","title":"Multitool.Collections.ListOperations.permutations/1","type":"function"},{"doc":"Returns a List where all elements of the given list are shifted one to the right. The last item in the List becomes the head after this operation is complete Parameters list : The List of items to shift one to the right Examples iex&gt; shift ( [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ] ) [ &quot;c&quot; , &quot;a&quot; , &quot;b&quot; ] iex&gt; shift ( [ 1 ] ) [ 1 ]","ref":"Multitool.Collections.ListOperations.html#shift/1","title":"Multitool.Collections.ListOperations.shift/1","type":"function"},{"doc":"The Numbers module holds helper functions for number operations such as primes and factors","ref":"Multitool.Numbers.html","title":"Multitool.Numbers","type":"module"},{"doc":"Shifts all digits one place to the right, bringing the right most digit to the leftmost position If the operation of bringing the rightmost digit to the leftmost position would result in the leading number of the resulting integer being a zero, the digits are repeatedly shifted until a zero is not in the leftmost position Parameters n : The integer to cycle Examples iex&gt; cycle ( 57 ) 75 iex&gt; cycle ( - 57 ) - 75 iex&gt; cycle ( 190 ) 901","ref":"Multitool.Numbers.html#cycle/1","title":"Multitool.Numbers.cycle/1","type":"function"},{"doc":"Shifts all digits to the right, repeated a given number of times. This operation operates the same as cycle/1 regarding leading zeroes If the operation of bringing the rightmost digit to the leftmost position would result in the leading number of the resulting integer being a zero, the digits are repeatedly shifted until a zero is not in the leftmost position Parameters n : The integer to cycle c : The amount of times to apply the cycle operation Examples iex&gt; cycle ( 57 , 1 ) 75 iex&gt; cycle ( - 57 , 2 ) - 57 iex&gt; cycle ( 190 , 2 ) 190","ref":"Multitool.Numbers.html#cycle/2","title":"Multitool.Numbers.cycle/2","type":"function"},{"doc":"Generates a MapSet of numbers resulting from cycling the given number so each digit is in each position once This operation operates the same as cycle/1 regarding leading zeroes If the operation of bringing the rightmost digit to the leftmost position would result in the leading number of the resulting integer being a zero, the digits are repeatedly shifted until a zero is not in the leftmost position Parameters n : The integer to generate cycles of Examples iex&gt; cycles ( 123 ) |&gt; MapSet . to_list ( ) [ 123 , 231 , 312 ] iex&gt; cycles ( - 57 ) |&gt; MapSet . to_list ( ) [ - 75 , - 57 ]","ref":"Multitool.Numbers.html#cycles/1","title":"Multitool.Numbers.cycles/1","type":"function"},{"doc":"Evaluates if a number is greater than negative one and does not have a remainder Parameters n : Integer to evaluate for naturalness Examples iex&gt; natural? ( - 5 ) false iex&gt; natural? ( 7 ) true iex&gt; natural? ( 7.5 ) false iex&gt; natural? ( 7.0 ) true","ref":"Multitool.Numbers.html#natural?/1","title":"Multitool.Numbers.natural?/1","type":"function"},{"doc":"Returns the given number without the leftmost digit When the given number is between negative nine and nine, zero is returned Parameters n : Integer to trim the leftmost digit off of Examples iex&gt; trim_left ( 57689 ) 7689 iex&gt; trim_left ( 7 ) 0 iex&gt; trim_left ( - 56788 ) - 6788 iex&gt; trim_left ( - 3 ) 0","ref":"Multitool.Numbers.html#trim_left/1","title":"Multitool.Numbers.trim_left/1","type":"function"},{"doc":"Returns the given number without the rightmost digit When the given number is between negative nine and nine, zero is returned Parameters n : Integer to trim the rightmost digit off of Examples iex&gt; trim_right ( 57689 ) 5768 iex&gt; trim_right ( 7 ) 0 iex&gt; trim_right ( - 56788 ) - 5678 iex&gt; trim_right ( - 3 ) 0","ref":"Multitool.Numbers.html#trim_right/1","title":"Multitool.Numbers.trim_right/1","type":"function"},{"doc":"Provides operations for working with the factorials of numbers The factorial of a number is the product of all numbers up to and including the number itself, starting at one","ref":"Multitool.Numbers.Factorial.html","title":"Multitool.Numbers.Factorial","type":"module"},{"doc":"Calculates the factorial of the given positive integer If a non-positive integer is provided, zero is returned Parameters n : Positive integer to calculate the factorial of Examples iex&gt; factorial ( 3 ) 6 iex&gt; factorial ( - 5 ) 0 iex&gt; factorial ( 10 ) 3628800","ref":"Multitool.Numbers.Factorial.html#factorial/1","title":"Multitool.Numbers.Factorial.factorial/1","type":"function"},{"doc":"Provides operations for working with the factors of numbers A factor of a number x is any number which divides x without a remainder. If x was 10 , the factors of x would be [1, 2, 5, 10]","ref":"Multitool.Numbers.Factors.html","title":"Multitool.Numbers.Factors","type":"module"},{"doc":"Given a number n , calculates the sum of all proper divisors of n , other than n itself Parameters n : A non - negative integer Examples iex&gt; aliquot_sum ( 3 ) 1 iex&gt; aliquot_sum ( 12 ) 16 iex&gt; aliquot_sum ( 100 ) 117","ref":"Multitool.Numbers.Factors.html#aliquot_sum/1","title":"Multitool.Numbers.Factors.aliquot_sum/1","type":"function"},{"doc":"Given a number n , classifies n as either pefect, abundant, or deficient If the aliquot sum of n is equal to n , n is perfect. If the sum exceeds n , it is abundant. Otherwise, it is deficient Parameters n : A non - negative integer Examples iex&gt; classify ( 3 ) :deficient iex&gt; classify ( 12 ) :abundant iex&gt; classify ( 28 ) :perfect","ref":"Multitool.Numbers.Factors.html#classify/1","title":"Multitool.Numbers.Factors.classify/1","type":"function"},{"doc":"Given a number n , retrieve a list of all factors for that number If n is less than one, return an empty list. The resulting list is not sorted. Parameters n : The number to retrieve factors of Examples iex&gt; factors_of ( 3 ) [ 1 , 3 ] iex&gt; factors_of ( 0 ) [ ] iex&gt; factors_of ( 100 ) [ 1 , 100 , 2 , 50 , 4 , 25 , 5 , 20 , 10 ]","ref":"Multitool.Numbers.Factors.html#factors_of/1","title":"Multitool.Numbers.Factors.factors_of/1","type":"function"},{"doc":"Given an integer n and sum_type , returns true if n can be represented as the sum of two numbers of the given type Always returns true if n is greater than 28123 and the type is abundant. False if less than one. All other values are computed Parameters n : An integer sum_type : An atom of either :abundant , :deficient , or :perfect Examples iex&gt; sum_type? ( 24 , :abundant ) true iex&gt; sum_type? ( 12 , :perfect ) true iex&gt; sum_type? ( 14 , :deficient ) true","ref":"Multitool.Numbers.Factors.html#sum_type?/2","title":"Multitool.Numbers.Factors.sum_type?/2","type":"function"},{"doc":"Given a range range , returns a list of integers that can be represented as the sum of two abundant numbers If no numbers in the range are the sum of two abundant numbers, an empty list is returned Parameters range : An integer range Examples iex&gt; sums_in ( 1 .. 25 , :abundant ) [ 24 ] iex&gt; sums_in ( 1 .. 5 , :deficient ) [ 2 , 3 , 4 , 5 ] iex&gt; sums_in ( 1 .. 1000 , :perfect ) [ 12 , 34 , 56 , 502 , 524 , 992 ]","ref":"Multitool.Numbers.Factors.html#sums_in/2","title":"Multitool.Numbers.Factors.sums_in/2","type":"function"},{"doc":"Given an integer n and sum_type , returns a list of tuples containg two numbers of the given type which sum to equal n If no two numbers of the given type sum to n , an empty list is returned. An empty list is returned for integers below one Parameters n : An integer sum_type : An atom of either :abundant , :deficient , or :perfect Examples iex&gt; sums_of_type ( 100 , :abundant ) [ { 12 , 88 } , { 20 , 80 } , { 30 , 70 } , { 40 , 60 } ] iex&gt; sums_of_type ( 5 , :deficient ) [ { 1 , 4 } , { 2 , 3 } ] iex&gt; sums_of_type ( 12 , :perfect ) [ { 6 , 6 } ]","ref":"Multitool.Numbers.Factors.html#sums_of_type/2","title":"Multitool.Numbers.Factors.sums_of_type/2","type":"function"},{"doc":"Provides operations for working with figurate numbers","ref":"Multitool.Numbers.Figurate.html","title":"Multitool.Numbers.Figurate","type":"module"},{"doc":"Given a positive integer n, returns the nth hexagonal number Negative integers return nil Parameters n : Integer . The nth hexagonal number to return Examples iex&gt; hexagonal ( 5 ) 45 iex&gt; hexagonal ( - 4 ) nil","ref":"Multitool.Numbers.Figurate.html#hexagonal/1","title":"Multitool.Numbers.Figurate.hexagonal/1","type":"function"},{"doc":"Given an Integer n, returns the position of the number in the hexagonal sequence Negative integers or integers not in the sequence return nil Parameters n : Integer . The number to test for being a hexagonal number Examples iex&gt; hexagonal? ( 630 ) 18 iex&gt; hexagonal? ( - 4 ) nil iex&gt; hexagonal? ( 29 ) nil","ref":"Multitool.Numbers.Figurate.html#hexagonal?/1","title":"Multitool.Numbers.Figurate.hexagonal?/1","type":"function"},{"doc":"Returns a List of the first n hexagonal numbers Providing a negative integer returns an empty List Parameters n : Integer . The number of hexagonal numbers to generate Examples iex&gt; hexagonals ( 3 ) [ 1 , 6 , 15 ] iex&gt; hexagonals ( - 4 ) [ ]","ref":"Multitool.Numbers.Figurate.html#hexagonals/1","title":"Multitool.Numbers.Figurate.hexagonals/1","type":"function"},{"doc":"Given a positive integer n, returns the nth pentagonal number Negative integers return nil Parameters n : Integer . The nth pentagonal number to return Examples iex&gt; pentagonal ( 5 ) 35 iex&gt; pentagonal ( - 4 ) nil","ref":"Multitool.Numbers.Figurate.html#pentagonal/1","title":"Multitool.Numbers.Figurate.pentagonal/1","type":"function"},{"doc":"Given an Integer n, returns the position of the number in the pentagonal sequence Negative integers or integers not in the sequence return nil Parameters n : Integer . The number to test for being a pentagonal number Examples iex&gt; pentagonal? ( 70 ) 7 iex&gt; pentagonal? ( - 4 ) nil iex&gt; pentagonal? ( 29 ) nil","ref":"Multitool.Numbers.Figurate.html#pentagonal?/1","title":"Multitool.Numbers.Figurate.pentagonal?/1","type":"function"},{"doc":"Returns a List of the first n pentagonal numbers Providing a negative integer returns an empty List Parameters n : Integer . The number of pentagonal numbers to generate Examples iex&gt; pentagonals ( 3 ) [ 1 , 5 , 12 ] iex&gt; pentagonals ( - 4 ) [ ]","ref":"Multitool.Numbers.Figurate.html#pentagonals/1","title":"Multitool.Numbers.Figurate.pentagonals/1","type":"function"},{"doc":"Given a positive integer n, returns the nth triangle number Negative integers return nil Parameters n : Integer . The nth triangle number to return Examples iex&gt; triangle ( 5 ) 15 iex&gt; triangle ( - 4 ) nil","ref":"Multitool.Numbers.Figurate.html#triangle/1","title":"Multitool.Numbers.Figurate.triangle/1","type":"function"},{"doc":"Given an Integer n, returns the position of the number in the triangular sequence Negative integers or integers not in the sequence return nil Parameters n : Integer . The number to test for being a triangle number Examples iex&gt; triangle? ( 630 ) 35 iex&gt; triangle? ( - 4 ) nil iex&gt; triangle? ( 29 ) nil","ref":"Multitool.Numbers.Figurate.html#triangle?/1","title":"Multitool.Numbers.Figurate.triangle?/1","type":"function"},{"doc":"Returns a List of the first n triangle numbers Providing a negative integer returns an empty List Parameters n : Integer . The number of triangle numbers to generate Examples iex&gt; triangles ( 3 ) [ 1 , 3 , 6 ] iex&gt; triangles ( - 4 ) [ ]","ref":"Multitool.Numbers.Figurate.html#triangles/1","title":"Multitool.Numbers.Figurate.triangles/1","type":"function"},{"doc":"Provides operations for working with prime numbers A number is prime if it has only two factors, itself and one","ref":"Multitool.Numbers.Primes.html","title":"Multitool.Numbers.Primes","type":"module"},{"doc":"Returns the next prime number to follow c Parameters c : Integer . The number to get the next prime after Examples iex&gt; next_prime ( 0 ) 2 iex&gt; next_prime ( 59651 ) 59659","ref":"Multitool.Numbers.Primes.html#next_prime/1","title":"Multitool.Numbers.Primes.next_prime/1","type":"function"},{"doc":"Returns the nth prime number, where the first prime number is two. Returns nil when n is less than one Parameters n : The nth prime number to retrieve Examples iex&gt; nth_prime ( 3 ) 5 iex&gt; nth_prime ( - 1 ) nil iex&gt; nth_prime ( 98764 ) 1282201","ref":"Multitool.Numbers.Primes.html#nth_prime/1","title":"Multitool.Numbers.Primes.nth_prime/1","type":"function"},{"doc":"","ref":"Multitool.Numbers.Primes.html#previous_prime/1","title":"Multitool.Numbers.Primes.previous_prime/1","type":"function"},{"doc":"Checks if the given number is a prime number. Returns true if the number is prime, false otherwise. Numbers less than two always return false Parameters n : Integer to check for primality Examples iex&gt; prime? ( - 1 ) false iex&gt; prime? ( 1 ) false iex&gt; prime? ( 3 ) true iex&gt; prime? ( 9800 ) false","ref":"Multitool.Numbers.Primes.html#prime?/1","title":"Multitool.Numbers.Primes.prime?/1","type":"function"},{"doc":"Generates a Stream of prime numbers, starting at the first prime number, two. This operation will produce prime numbers until a terminating condition is reached Examples iex&gt; primes ( ) |&gt; Enum . take ( 0 ) [ ] iex&gt; primes ( ) |&gt; Enum . take ( 1 ) [ 2 ] iex&gt; primes ( ) |&gt; Enum . take ( 10 ) [ 2 , 3 , 5 , 7 , 11 , 13 , 17 , 19 , 23 , 29 ]","ref":"Multitool.Numbers.Primes.html#primes/0","title":"Multitool.Numbers.Primes.primes/0","type":"function"},{"doc":"Generates a list of n prime numbers, starting at the first prime number, two. An empty list is returned when n is less than one Parameters n : The number of prime numbers to generate Examples iex&gt; primes ( - 1 ) [ ] iex&gt; primes ( 1 ) [ 2 ] iex&gt; primes ( 10 ) [ 2 , 3 , 5 , 7 , 11 , 13 , 17 , 19 , 23 , 29 ]","ref":"Multitool.Numbers.Primes.html#primes/1","title":"Multitool.Numbers.Primes.primes/1","type":"function"},{"doc":"Returns a Stream that returns prime numbers that occur after the given number This operation will produce prime numbers until a terminating condition is reached Parameters n : An integer to generate primes after Examples iex&gt; primes_after ( 2 ) |&gt; Enum . take ( 1 ) [ 3 ] iex&gt; primes_after ( 0 ) |&gt; Enum . take ( 2 ) [ 2 , 3 ]","ref":"Multitool.Numbers.Primes.html#primes_after/1","title":"Multitool.Numbers.Primes.primes_after/1","type":"function"},{"doc":"Returns a list of n primes that occur after, and not including, c Parameters c : Integer . The number to generate primes after n : Integer . The number of primes to generate Examples iex&gt; primes_after ( 2 , 1 ) [ 3 ] iex&gt; primes_after ( 0 , 2 ) [ 2 , 3 ]","ref":"Multitool.Numbers.Primes.html#primes_after/2","title":"Multitool.Numbers.Primes.primes_after/2","type":"function"},{"doc":"Returns a list of prime numbers that occur before the given integer n An empty list is returned when n is less than three Parameters n : An integer to retrieve preceding primes of Examples iex&gt; primes_before ( 3 ) [ 2 ] iex&gt; primes_before ( 2 ) [ ] iex&gt; primes_before ( 10 ) [ 7 , 5 , 3 , 2 ]","ref":"Multitool.Numbers.Primes.html#primes_before/1","title":"Multitool.Numbers.Primes.primes_before/1","type":"function"},{"doc":"Returns a list of n primes that occur before, and not including, c Parameters c : Integer . The number to generate primes before n : Integer . The number of primes to generate Examples iex&gt; primes_before ( 5 , 2 ) [ 3 , 2 ] iex&gt; primes_before ( 2 ) [ ]","ref":"Multitool.Numbers.Primes.html#primes_before/2","title":"Multitool.Numbers.Primes.primes_before/2","type":"function"},{"doc":"Provides operations that generate sequences of numbers","ref":"Multitool.Numbers.Sequence.html","title":"Multitool.Numbers.Sequence","type":"module"},{"doc":"Provides the Collatz sequence starting with the given number and ending at 1 Returns an empty list if a number less than 1 is provided Parameters n : Positive integer to begin the sequence at Examples iex&gt; collatz ( 2 ) [ 2 , 1 ] iex&gt; collatz ( 0 ) [ ] iex&gt; collatz ( 3 ) [ 3 , 10 , 5 , 16 , 8 , 4 , 2 , 1 ]","ref":"Multitool.Numbers.Sequence.html#collatz/1","title":"Multitool.Numbers.Sequence.collatz/1","type":"function"},{"doc":"Given the integer n , returns the length of the resulting Collatz sequence, including the starting integer Returns zero when the provided integer is less than one. This method is optimized for calculating the length over taking the length of the resulting list of collatz/1 Parameters n : Positive integer Examples iex&gt; collatz_len ( 2 ) 2 iex&gt; collatz_len ( 0 ) 0 iex&gt; collatz_len ( 3 ) 8","ref":"Multitool.Numbers.Sequence.html#collatz_len/1","title":"Multitool.Numbers.Sequence.collatz_len/1","type":"function"},{"doc":"Returns a Stream that supplies the Fibonacci sequence, starting at 1 Examples iex&gt; fibonacci ( ) |&gt; Enum . take ( 10 ) [ 1 , 1 , 2 , 3 , 5 , 8 , 13 , 21 , 34 , 55 ]","ref":"Multitool.Numbers.Sequence.html#fibonacci/0","title":"Multitool.Numbers.Sequence.fibonacci/0","type":"function"},{"doc":"Returns a list of the first n integers in the Fibonacci sequence An empty list is returned if a number less than 1 is provided Parameters n : An integer , the number of digits in the sequence to retrieve Examples iex&gt; fibonacci ( 10 ) [ 1 , 1 , 2 , 3 , 5 , 8 , 13 , 21 , 34 , 55 ]","ref":"Multitool.Numbers.Sequence.html#fibonacci/1","title":"Multitool.Numbers.Sequence.fibonacci/1","type":"function"},{"doc":"Returns the integer at the nth position in the Fibonacci sequence, where the first integer in the sequence is 1 When an integer less than zero is provided, nil is returned. When zero is provided, zero is returned. All other values are computed Parameters n : An integer , the nth digit to retrieve from the Fibonacci sequence Examples iex&gt; nth_fibonacci ( 10 ) 55 iex &gt; nth_fibonacci ( - 1 ) nil iex&gt; nth_fibonacci ( 0 ) 0","ref":"Multitool.Numbers.Sequence.html#nth_fibonacci/1","title":"Multitool.Numbers.Sequence.nth_fibonacci/1","type":"function"},{"doc":"Provides operations for working with triangular numbers A triangular number is generated by adding the natural numbers up to and including the number n . The 4th triangular number, for example, can be calculated as follows: 1 + 2 + 3 + 4 = 10","ref":"Multitool.Numbers.Triangular.html","title":"Multitool.Numbers.Triangular","type":"module"},{"doc":"Returns the nth triangle number where the first triangle number is one. If n is less than one, zero is returned Parameters n : The nth triangle number to retrieve Examples iex&gt; nth_triangle_num ( 3 ) 6 iex&gt; nth_triangle_num ( - 1 ) 0 iex&gt; nth_triangle_num ( 34 ) 595","ref":"Multitool.Numbers.Triangular.html#nth_triangle_num/1","title":"Multitool.Numbers.Triangular.nth_triangle_num/1","type":"function"},{"doc":"Returns a list of the first n triangle numbers, starting at one If n is less than one, an empty list is returned Parameters n : The number of triangle numbers to retrieve Examples iex&gt; triangle_nums ( 3 ) [ 1 , 3 , 6 ] iex&gt; triangle_nums ( - 1 ) [ ] iex&gt; triangle_nums ( 5 ) [ 1 , 3 , 6 , 10 , 15 ]","ref":"Multitool.Numbers.Triangular.html#triangle_nums/1","title":"Multitool.Numbers.Triangular.triangle_nums/1","type":"function"}]